pro uti_vel_fix, ref=ref, band=band

common global
common data_set

if (keyword_set(ref) eq 0 or (keyword_set(band) eq 0)) then begin
   print, 'Please set the reference band and the target band '
   print, '      with keywords ref and band.' 
   print, 'Quit!'
   return
endif


if ((strpos(ref,'s') eq -1 or strpos(band,'s') eq -1)) then begin
   print, 'Please check the input band name again !'
   print, 'No velocity change made, Quit!'
   return
endif

result=dat_filter(s_s,/save,/no_notify)
command='"band" eq "'+ref+'"'
result=dat_filter(s_f,command,/no_notify,/reset)

f0=sp[psf].fsky
v0=sp[psf].vel
fs=f0/sqrt((1-v0*1000.d/!cvel)/(1+v0*1000.d/!cvel))

command='"band" eq "'+band+'"'
result1=dat_filter(s_f,command,/no_notify,/reset)
if result ne result1 then begin
   print, 'Inconsistent scan numbers for both bands, Quit!'
   return
endif
   
f1=sp[psf].fsky
alpha=(f1/fs)^2.
sp[psf].vel=-(alpha-1.)*!cvel/(1000.d*(alpha+1.))
;sp[psf].vel=v1

result=dat_filter(s_s,/restore,/no_notify)
print, 'Velocity header fixed on band '+band+' using band '+ref 
end
