#include <math.h>
#include <rpc/rpc.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <time.h>
#include <sys/ddi.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <limits.h>

#include "data_write.h"

unsigned long mfsize(FILE *);
struct inh_int_def {
	int  a[512];
};

main (int argc, char **argv)
{

char location[6][36];
char pathname[36];
char filename[6][36];
int set,nsets[6];
int file,nfiles = 6;
int headerbytes[6];

FILE* fpin[6];

int i,j,k,l,m,n;

int difference;
long imax,bytepos,nbytes,datalength;
long *data_start_pos;
int firstbsl,lastbsl,inhid;
int numberBaselines,numberSpectra,numberSidebands;
int blhid,firstsp,lastsp;
int inhset,blhset,sphset;
short int realvisS,imagvisS,scale;
float realvisF[128],imagvisF[128];
short int *shortdata;

struct inh_def   **inh;
struct blh_def   **blh;
struct sph_def   **sph;
struct codeh_def **cdh;
struct ant_def   **enh;
struct sch_def   **sch;

struct inh_def *inh_read(FILE *);
struct blh_def *blh_read(FILE * );
struct sph_def *sph_read(FILE * );
struct codeh_def *cdh_read(FILE * );
struct ant_def *enh_read(FILE * );
struct sch_def *sch_head_read(FILE * );
int sch_data_read(FILE *, long int, short int * );
/* ----------------------------------------------------------- */

strcpy(pathname,argv[1]);
strcpy(filename[0],"in_read");
strcpy(filename[1],"bl_read");
strcpy(filename[2],"sp_read");
strcpy(filename[3],"codes_read");
strcpy(filename[4],"eng_read");
strcpy(filename[5],"sch_read");

/* number of bytes in each type of header. */
/* sch is variable number of bytes */

headerbytes[0] = 132;
headerbytes[1] = 118;
headerbytes[2] = 100;
headerbytes[3] = 42;
headerbytes[4] = 188;
headerbytes[5] = 0;

/* ----------------------------------------------------------- */
/* Open all the files */

for (file=0;file<nfiles;file++){

  strcpy(location[file],pathname); 
  strcat(location[file],filename[file]);
  fpin[file] = fopen(location[file],"r");
        if (fpin[file] == NULL) {
                printf("Problem opening the file %s\n",location[file]);
                perror("file open problem");
                exit(-1);
        } else {
                printf("Found file %s\n",location[file]);
        }
}


/* ----------------------------------------------------------- */

/* Get the size of each file and compute the number of headers */

for (file=0;file<nfiles;file++){
  if(file < 5 ){
    imax = mfsize(fpin[file]);
    nsets[file] = imax / headerbytes[file];
    printf("file %s size %d sets %d\n",location[file],imax,nsets[file]);
  }
}


/* ---------------------------------------------------------------------- */

/* Allocate memory to store all the headers */

  inh = (struct inh_def **) malloc(nsets[0]*sizeof( struct inh_def *));
  for (set=0;set<nsets[0];set++) {
    inh[set] = (struct inh_def *)malloc(sizeof(struct inh_def ));
    if (inh[set] == NULL ){
      printf("ERROR: Memory allocation for inh failed trying to allocate %d bytes\n",
                        nsets[0]*sizeof(struct inh_def));
      exit(-1);
    }
  }

  blh = (struct blh_def **) malloc(nsets[1]*sizeof( struct blh_def *));
  for (set=0;set<nsets[1];set++) {
    blh[set] = (struct blh_def *)malloc(sizeof(struct blh_def ));
    if (blh[set] == NULL ){
      printf("ERROR: Memory allocation for blh failed trying to allocate %d bytes\n",
                        nsets[1]*sizeof(struct blh_def));
      exit(-1);
    }
  }


  sph = (struct sph_def **) malloc(nsets[2]*sizeof( struct sph_def *));
  for (set=0;set<nsets[2];set++) {
    sph[set] = (struct sph_def *)malloc(sizeof(struct sph_def ));
    if (sph[set] == NULL ){
      printf("ERROR: Memory allocation for sph failed trying to allocate %d bytes\n",
                        nsets[2]*sizeof(struct sph_def));
      exit(-1);
    }
  }


  cdh = (struct codeh_def **) malloc(nsets[3]*sizeof( struct codeh_def *));
  for (set=0;set<nsets[3];set++) {
    cdh[set] = (struct codeh_def *)malloc(sizeof(struct codeh_def ));
    if (cdh[set] == NULL ){
      printf("ERROR: Memory allocation for cdh failed trying to allocate %d bytes\n",
                        nsets[3]*sizeof(struct codeh_def));
      exit(-1);
    }
  }

  enh = (struct ant_def **) malloc(nsets[4]*sizeof( struct ant_def *));
  for (set=0;set<nsets[4];set++) {
    enh[set] = (struct ant_def *)malloc(sizeof(struct ant_def ));
    if (enh[set] == NULL ){
      printf("ERROR: Memory allocation for enh failed trying to allocate %d bytes\n",
                        nsets[4]*sizeof(struct ant_def));
      exit(-1);
    }
  }

  sch = (struct sch_def **) malloc(nsets[0]*sizeof( struct sch_def *));
  for (set=0;set<nsets[0];set++) {
    sch[set] = (struct sch_def *)malloc(sizeof(struct sch_def ));
    if (sch[set] == NULL ){
      printf("ERROR: Memory allocation for sch failed trying to allocate %d bytes\n",
                        nsets[0]*sizeof(struct sch_def));
      exit(-1);
    }
  }
/* At this point, only enough memory has been allocated to read the data
   headers, not the data itself. */

/* Need an array to hold the starting byte for each integration of data */
  data_start_pos = (long int*)malloc(nsets[0]*sizeof(long int));

/* ---------------------------------------------------------------------- */
/* Read the headers */

  for (set=0;set<nsets[0];set++) {
	*inh[set] = *(inh_read(fpin[0]));
	printf("INTEGRATION NUMBER %d %d\n",inh[set]->ints,inh[set]->inhid);
  }
printf("FINISHED READING  IN HEADERS\n");

  for (set=0;set<nsets[1];set++) {
	*blh[set] = *(blh_read(fpin[1]));
/*	printf("%d INTEGRATION BASELINE %d %d\n",set,blh[set]->inhid,blh[set]->blhid);
*/
  }
printf("FINISHED READING  BL HEADERS\n");

  for (set=0;set<nsets[2];set++) {
	*sph[set] = *(sph_read(fpin[2]));
	printf("%d INT NCH NREC OFF %d %d %d %d\n",
          set,sph[set]->inhid,sph[set]->nch,sph[set]->nrec,sph[set]->dataoff);

  }
printf("FINISHED READING  SP HEADERS\n");

  for (set=0;set<nsets[3];set++){
	*cdh[set] = *(cdh_read(fpin[3]));
/*        printf("%d CODE NAME %s  STRING %s\n",set,cdh[set]->v_name,cdh[set]->code);
*/
  }
printf("FINISHED READING  CD HEADERS\n");

  for (set=0;set<nsets[4];set++) {
	*enh[set] = *(enh_read(fpin[4]));
	printf("INTEGRATION NUMBER %d  ANT %d\n",
          enh[set]->ints,enh[set]->antennaNumber);
        printf("    pad %d \n",enh[set]->padNumber);
        printf("    pmdaz %f pmdel %f\n",enh[set]->pmdaz,enh[set]->pmdaz);
  }
printf("FINISHED READING  EN HEADERS\n");

/* Now start with the data. In front of every set of
   data is a small 10 byte header */

/* read these data integration headers skipping over the data.  */

  for (set=0;set<nsets[0];set++) { 
        data_start_pos[set] = ftell(fpin[5]);
        printf("set %d data_start_pos %d\n",set,data_start_pos[set]);
        *sch[set] = *(sch_head_read(fpin[5]));
        printf("SCH: inh %d form %c%c%c%c nbyt %d nbyt_pack %d\n",
           sch[set]->inhid,
           sch[set]->form[0],
           sch[set]->form[1],
           sch[set]->form[2],
           sch[set]->form[3],
           sch[set]->nbyt,
           sch[set]->nbyt_pack);

/* skip over the data to the next integration header */
       i = fseek(fpin[5],(long int)sch[set]->nbyt,SEEK_CUR);
  }

/* reset the file to the beginning since we only read the headers */
  rewind(fpin[5]);



/* Here are some examples of extracting data. */

/* For some  integration number, find all the baseline headers */

  firstbsl = -1;
  lastbsl  = -1;

/* pick the 3rd integration */
  inhset = 2;

/* get the id number */
  inhid = inh[inhset]->inhid;
  printf("The integration id number is %d\n",inhid);

/* find all the baselines which have this integration id number */
/* In our data, all the data is written sequentially so it is safe
   to assume a certain ordering. */

  printf("The following baselines belong to this integration\n");
  for (set=0;set<nsets[2];set++) { 
    if (firstbsl == -1 && blh[set]->inhid == inhid) {
       firstbsl = set;
    }
    if (firstbsl != -1 && blh[set]->inhid != inhid) {
       lastbsl = set - 1;
    }
    if (lastbsl != -1) break;
  }
  printf("first matching baseline is %d and last is %d\n",firstbsl,lastbsl);
  numberBaselines = lastbsl-firstbsl+1;
  printf("There are %d baselines in this integration\n",numberBaselines);
  printf("The baseline id numbers for these baselines are: ");
  for(i=firstbsl;i<=lastbsl;i++) printf(" %d ",blh[i]->blhid);
  printf("\n");
  printf("The actual baselines are: ");
  for(i=firstbsl;i<=lastbsl;i++) printf(" %d-%d ",blh[i]->itel1,blh[i]->itel2);
  printf("\n");
  printf("The sidebands are: ");
  for(i=firstbsl;i<=lastbsl;i++) printf(" %d ",blh[i]->isb);
  printf("\n");
  numberSidebands = 1;
  for(i=firstbsl;i<=lastbsl;i++) if(blh[i]->isb > 0) numberSidebands = 2;
  printf("The number of sidebands is %d\n",numberSidebands);

/* now look at the spectra header. in general there are 5 spectra for
   each baseline. (There is a separate baseline for each sideband.)  */


/* pick the 2th baseline */
  blhset = 1;
  blhid = blh[blhset]->blhid;

  firstsp = -1;
  lastsp  = -1;
  printf("The following spectra belong to this baseline\n");
  for (set=0;set<nsets[2];set++) { 
    if (firstsp == -1 && sph[set]->blhid == blhid) {
       firstsp = set;
    }
    if (firstsp  != -1 && sph[set]->blhid != blhid) {
       lastsp  = set - 1;
    }
    if (lastsp  != -1) break;
  }

  printf("first matching spectrum is %d and last is %d\n",firstsp,lastsp );
  numberSpectra   = lastsp -firstsp +1;
  printf("There are %d spectra with this baseline \n",numberSpectra  );
  printf("The number of channels in each spectrum is:  \n");
  for(i=firstsp;i<=lastsp;i++) printf("%d  ",sph[i]->nch);
  printf("\n");

/* Now get the data for the continuum channel */
  sphset = firstsp;

/* The data for this spectrum consists of a 5 short int record header 
   and the data  which is a short for each real and a short for 
   each imag vis */

   datalength = 5 + 2*sph[sphset]->nch;
   printf("The data length is %d\n",datalength);

/* Get some memory to hold the data */
   shortdata = (short int* )malloc(datalength*sizeof(short int));
   printf("shortdata memory allocated \n");


/* Here is the starting byte for the data for this spectrum */
/* The 16 is to skip over the data integration header which precedes 
   all the records. We already read this data integration header 
   with sch_head_read  */

  bytepos = 16 + data_start_pos[inhset] + sph[sphset]->dataoff ;

  printf("The byte offset for this spectrum is %d bytes\n",sph[sphset]->dataoff);
  printf("The byte offset for the integration is %d bytes\n",data_start_pos[inhset]);
  printf("The record for spectrum %d starts at %d bytes \n",
     sph[sphset]->sphid, bytepos);

/* Move to this position in the file and read the data */
  fseek(fpin[5],bytepos,SEEK_SET);
  nbytes = sch_data_read(fpin[5],datalength,shortdata);

/* take a look at the record header */
  printf("Integration time %4d msec\n",shortdata[0]);
  printf("Time offset      %4d msec\n",shortdata[1]);
  printf("Noise estimate   %d\n",shortdata[2]);
  printf("Noise estimate   %d\n",shortdata[3]);
  printf("Scale            %d\n",shortdata[4]);

/* There is a different scale factor for each record (spectrum) */
  scale = shortdata[4];

/* Now the data There is only one channel for the continuum*/

    realvisS = shortdata[5];
    imagvisS = shortdata[6];
    realvisF[0] = pow(2.,(double)scale)*realvisS;
    imagvisF[0] = pow(2.,(double)scale)*imagvisS;
    printf("Real as short %d    as float %g\n",realvisS,realvisF[0]);
    printf("Imag as short %d    as float %g\n",imagvisS,imagvisF[0]);

    free(shortdata);

/* Read the next spectrum, this shows how to read sequentially moving
   from the current position.  */


/* The file is positioned at the record header for the next spectrum. */
/* There is no 16 byte integration header between records */

   sphset ++;
   datalength = 5 + 2*sph[sphset]->nch;
   printf("The data length is %d\n",datalength);

/* Get some memory to hold the data */
   shortdata = (short int* )malloc(datalength*sizeof(short int));

  nbytes = sch_data_read(fpin[5],datalength,shortdata);

/* take a look at the record header */
  printf("Integration time %4d msec\n",shortdata[0]);
  printf("Time offset      %4d msec\n",shortdata[1]);
  printf("Noise estimate   %d\n",shortdata[2]);
  printf("Noise estimate   %d\n",shortdata[3]);
  printf("Scale            %d\n",shortdata[4]);

/* There is a different scale factor for each record (spectrum) */
  scale = shortdata[4];

/* Now the channel data.  */

  for(i=0;i<sph[sphset]->nch;i++){
    realvisS = shortdata[5+2*i];
    imagvisS = shortdata[5+2*i+1];
    realvisF[i] = pow(2.,(double)scale)*realvisS;
    imagvisF[i] = pow(2.,(double)scale)*imagvisS;
    if (i < 10) {
      printf("Real as short %d    as float %g\n",realvisS,realvisF[i]);
      printf("Imag as short %d    as float %g\n",imagvisS,imagvisF[i]);
    }
  }

/* ---------------------------------------------------------------------- */



} /* end of main */

/* This function reads the integration header */
struct inh_def * inh_read(FILE * fpinh)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */

  struct inh_def inh;
 
        nbytes = 0;
        nobj = 0;

/* read first data in set and check for end of file */
 
        nobj += fread(&inh.conid,sizeof(inh.conid),1,fpinh);
        if (nobj == 0) {
          printf("Unexpected end of file in_read\n");
          exit(-1);
        }
        nbytes += sizeof(inh.conid);
        nobj += fread(&inh.icocd,sizeof(inh.icocd),1,fpinh);
        nbytes += sizeof(inh.icocd);
        nobj += fread(&inh.traid,sizeof(inh.traid),1,fpinh);
        nbytes += sizeof(inh.traid);
        nobj += fread(&inh.inhid,sizeof(inh.inhid),1,fpinh);
        nbytes += sizeof(inh.inhid);
        nobj += fread(&inh.ints,sizeof(inh.ints),1,fpinh);
        nbytes += sizeof(inh.ints);
        nobj += fread(&inh.itq,sizeof(inh.itq),1,fpinh);
        nbytes += sizeof(inh.itq);
        nobj += fread(&inh.az,sizeof(inh.az),1,fpinh);
        nbytes += sizeof(inh.az);
        nobj += fread(&inh.el,sizeof(inh.el),1,fpinh);
        nbytes += sizeof(inh.el);
        nobj += fread(&inh.ha,sizeof(inh.ha),1,fpinh);
        nbytes += sizeof(inh.ha);
        nobj += fread(&inh.iut,sizeof(inh.iut),1,fpinh);
        nbytes += sizeof(inh.iut);
        nobj += fread(&inh.iref_time,sizeof(inh.iref_time),1,fpinh);
        nbytes += sizeof(inh.iref_time);
        nobj += fread(&inh.dhrs,sizeof(inh.dhrs),1,fpinh);
        nbytes += sizeof(inh.dhrs);
        nobj += fread(&inh.vc,sizeof(inh.vc),1,fpinh);
        nbytes += sizeof(inh.vc);
        nobj += fread(&inh.ivctype,sizeof(inh.ivctype),1,fpinh);
        nbytes += sizeof(inh.ivctype);
        nobj += fread(&inh.sx,sizeof(inh.sx),1,fpinh);
        nbytes += sizeof(inh.sx);
        nobj += fread(&inh.sy,sizeof(inh.sy),1,fpinh);
        nbytes += sizeof(inh.sy);
        nobj += fread(&inh.sz,sizeof(inh.sz),1,fpinh);
        nbytes += sizeof(inh.sz);
        nobj += fread(&inh.rinteg,sizeof(inh.rinteg),1,fpinh);
        nbytes += sizeof(inh.rinteg);
        nobj += fread(&inh.proid,sizeof(inh.proid),1,fpinh);
        nbytes += sizeof(inh.proid);
        nobj += fread(&inh.souid,sizeof(inh.souid),1,fpinh);
        nbytes += sizeof(inh.souid);
        nobj += fread(&inh.isource,sizeof(inh.isource),1,fpinh);
        nbytes += sizeof(inh.isource);
        nobj += fread(&inh.ipos,sizeof(inh.ipos),1,fpinh);
        nbytes += sizeof(inh.ipos);
        nobj += fread(&inh.offx,sizeof(inh.offx),1,fpinh);
        nbytes += sizeof(inh.offx);
        nobj += fread(&inh.offy,sizeof(inh.offy),1,fpinh);
        nbytes += sizeof(inh.offy);
        nobj += fread(&inh.iofftype,sizeof(inh.iofftype),1,fpinh);
        nbytes += sizeof(inh.iofftype);
        nobj += fread(&inh.ira,sizeof(inh.ira),1,fpinh);
        nbytes += sizeof(inh.ira);
        nobj += fread(&inh.idec,sizeof(inh.idec),1,fpinh);
        nbytes += sizeof(inh.idec);
        nobj += fread(&inh.rar,sizeof(inh.rar),1,fpinh);
        nbytes += sizeof(inh.rar);
        nobj += fread(&inh.decr,sizeof(inh.decr),1,fpinh);
        nbytes += sizeof(inh.decr);
        nobj += fread(&inh.epoch,sizeof(inh.epoch),1,fpinh);
        nbytes += sizeof(inh.epoch);
        nobj += fread(&inh.sflux,sizeof(inh.sflux),1,fpinh);
        nbytes += sizeof(inh.sflux);
        nobj += fread(&inh.size,sizeof(inh.size),1,fpinh);
        nbytes += sizeof(inh.size);

/*      printf("Read  %d variables and %d bytes from in_read\n",nobj,nbytes); */
        return &inh;
 
} /* end of function inh_read */


/* This function reads one baseline header */
struct blh_def *blh_read(FILE * fpblh)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */
  struct blh_def blh;
 
        nbytes = 0;
        nobj = 0;
 
 
        nobj += fread(&blh.blhid,sizeof(blh.blhid),1,fpblh);
        if (nobj == 0) {
          printf("Unexpected end of file bl_read\n");
          exit(-1);
        }
        nbytes += sizeof(blh.blhid);
        nobj += fread(&blh.inhid,sizeof(blh.inhid),1,fpblh);
        nbytes += sizeof(blh.inhid);
        nobj += fread(&blh.isb,sizeof(blh.isb),1,fpblh);
        nbytes += sizeof(blh.isb);
        nobj += fread(&blh.ipol,sizeof(blh.ipol),1,fpblh);
        nbytes += sizeof(blh.ipol);
        nobj += fread(&blh.pa,sizeof(blh.pa),1,fpblh);
        nbytes += sizeof(blh.pa);
        nobj += fread(&blh.iaq,sizeof(blh.iaq),1,fpblh);
        nbytes += sizeof(blh.iaq);
        nobj += fread(&blh.ibq,sizeof(blh.ibq),1,fpblh);
        nbytes += sizeof(blh.ibq);
        nobj += fread(&blh.icq,sizeof(blh.icq),1,fpblh);
        nbytes += sizeof(blh.icq);
        nobj += fread(&blh.ioq,sizeof(blh.ioq),1,fpblh);
        nbytes += sizeof(blh.ioq);
        nobj += fread(&blh.irec,sizeof(blh.irec),1,fpblh);
        nbytes += sizeof(blh.irec);
        nobj += fread(&blh.iifc,sizeof(blh.iifc),1,fpblh);
        nbytes += sizeof(blh.iifc);
        nobj += fread(&blh.u,sizeof(blh.u),1,fpblh);
        nbytes += sizeof(blh.u);
        nobj += fread(&blh.v,sizeof(blh.v),1,fpblh);
        nbytes += sizeof(blh.v);
        nobj += fread(&blh.w,sizeof(blh.w),1,fpblh);
        nbytes += sizeof(blh.w);
        nobj += fread(&blh.prbl,sizeof(blh.prbl),1,fpblh);
        nbytes += sizeof(blh.prbl);
        nobj += fread(&blh.angres,sizeof(blh.angres),1,fpblh);
        nbytes += sizeof(blh.angres);
        nobj += fread(&blh.vis,sizeof(blh.vis),1,fpblh);
        nbytes += sizeof(blh.vis);
        nobj += fread(&blh.coh,sizeof(blh.coh),1,fpblh);
        nbytes += sizeof(blh.coh);
        nobj += fread(&blh.sigcoh,sizeof(blh.sigcoh),1,fpblh);
        nbytes += sizeof(blh.sigcoh);
        nobj += fread(&blh.csnr,sizeof(blh.csnr),1,fpblh);
        nbytes += sizeof(blh.csnr);
        nobj += fread(&blh.vflux,sizeof(blh.vflux),1,fpblh);
        nbytes += sizeof(blh.vflux);
        nobj += fread(&blh.cnoise,sizeof(blh.cnoise),1,fpblh);
        nbytes += sizeof(blh.cnoise);
        nobj += fread(&blh.avedhrs,sizeof(blh.avedhrs),1,fpblh);
        nbytes += sizeof(blh.avedhrs);
        nobj += fread(&blh.ampave,sizeof(blh.ampave),1,fpblh);
        nbytes += sizeof(blh.ampave);
        nobj += fread(&blh.phaave,sizeof(blh.phaave),1,fpblh);
        nbytes += sizeof(blh.phaave);
        nobj += fread(&blh.tpvar,sizeof(blh.tpvar),1,fpblh);
        nbytes += sizeof(blh.tpvar);
        nobj += fread(&blh.blsid,sizeof(blh.blsid),1,fpblh);
        nbytes += sizeof(blh.blsid);
        nobj += fread(&blh.itel1,sizeof(blh.itel1),1,fpblh);
        nbytes += sizeof(blh.itel1);
        nobj += fread(&blh.itel2,sizeof(blh.itel2),1,fpblh);
        nbytes += sizeof(blh.itel2);
        nobj += fread(&blh.iblcd,sizeof(blh.iblcd),1,fpblh);
        nbytes += sizeof(blh.iblcd);
        nobj += fread(&blh.ble,sizeof(blh.ble),1,fpblh);
        nbytes += sizeof(blh.ble);
        nobj += fread(&blh.bln,sizeof(blh.bln),1,fpblh);
        nbytes += sizeof(blh.bln);
        nobj += fread(&blh.blu,sizeof(blh.blu),1,fpblh);
        nbytes += sizeof(blh.blu);
        nobj += fread(&blh.soid,sizeof(blh.soid),1,fpblh);
        nbytes += sizeof(blh.soid);
 
 
/* printf("Wrote %d variables and %d bytes to bl_read\n",nobj,nbytes); */

        return &blh  ;
 
} /* end of blh_read  */


unsigned long mfsize(FILE *fp)
{

    /* Optimization stuff */
    char temp[BUFSIZ];
    static const long DATALENGTH_MAX=LONG_MAX%2!=0?LONG_MAX-1:LONG_MAX;
    long datalength=DATALENGTH_MAX;

    unsigned long i, counter, fsize;
    fsize = 0;

    if (fp==NULL)
    {
     printf("null pointer\n");
     return NULL;
    }


/* fseek() doesn't signal EOF so i use fread() to detect the end of file */
for (fseek(fp, datalength-1, SEEK_SET); 
    datalength>0 && fread(temp, 1, 1, fp)==0; 
       fseek(fp, datalength-1, SEEK_SET)) datalength/=128;

    fseek(fp, 0, SEEK_SET);
	
    if (datalength==0 && fread(temp, 1, 1, fp)==0)
    {
        return fsize;
    }

    else if (datalength==0)
           datalength=BUFSIZ;

    fseek(fp, datalength-1, SEEK_SET);


    /* fseek() doesn't signal EOF so i use fread() to detect the end of file */
    for(counter=0; fread(temp, 1, 1, fp)!=0; ++counter)
    	fseek(fp, datalength-1, SEEK_CUR);

    fseek(fp, 0, SEEK_SET);

    for( ; counter>0; --counter)
    {
        fseek(fp, datalength, SEEK_CUR);
        fsize += datalength;

    }

    do
    {
        fsize += datalength=fread(temp, 1, BUFSIZ, fp);

    }while(datalength!=0);

    fseek(fp, 0, SEEK_SET);

    return fsize;
}


struct sph_def *sph_read(FILE * fpsph)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */
 
  struct sph_def sph;
 
        nbytes = 0;
        nobj = 0;
 
        nobj += fread(&sph.sphid,sizeof(sph.sphid),1,fpsph);
        if (nobj == 0) {
          printf("Unexpected end of file sp_read\n");
          exit(-1);
        }
        nbytes += sizeof(sph.sphid);
        nobj += fread(&sph.blhid,sizeof(sph.blhid),1,fpsph);
        nbytes += sizeof(sph.blhid);
        nobj += fread(&sph.inhid,sizeof(sph.inhid),1,fpsph);
        nbytes += sizeof(sph.inhid);
        nobj += fread(&sph.igq,sizeof(sph.igq),1,fpsph);
        nbytes += sizeof(sph.igq);
        nobj += fread(&sph.ipq,sizeof(sph.ipq),1,fpsph);
        nbytes += sizeof(sph.ipq);
        nobj += fread(&sph.iband,sizeof(sph.iband),1,fpsph);
        nbytes += sizeof(sph.iband);
        nobj += fread(&sph.ipstate,sizeof(sph.ipstate),1,fpsph);
        nbytes += sizeof(sph.ipstate);
        nobj += fread(&sph.tau0,sizeof(sph.tau0),1,fpsph);
        nbytes += sizeof(sph.tau0);
        nobj += fread(&sph.vel,sizeof(sph.vel),1,fpsph);
        nbytes += sizeof(sph.vel);
        nobj += fread(&sph.vres,sizeof(sph.vres),1,fpsph);
        nbytes += sizeof(sph.vres);
        nobj += fread(&sph.ivtype,sizeof(sph.ivtype),1,fpsph);
        nbytes += sizeof(sph.ivtype);
        nobj += fread(&sph.fsky,sizeof(sph.fsky),1,fpsph);
        nbytes += sizeof(sph.fsky);
        nobj += fread(&sph.fres,sizeof(sph.fres),1,fpsph);
        nbytes += sizeof(sph.fres);
        nobj += fread(&sph.tssb,sizeof(sph.tssb),1,fpsph);
        nbytes += sizeof(sph.tssb);
        nobj += fread(&sph.integ,sizeof(sph.integ),1,fpsph);
        nbytes += sizeof(sph.integ);
        nobj += fread(&sph.wt,sizeof(sph.wt),1,fpsph);
        nbytes += sizeof(sph.wt); 
        nobj += fread(&sph.itaper,sizeof(sph.itaper),1,fpsph);
        nbytes += sizeof(sph.itaper);
        nobj += fread(&sph.snoise,sizeof(sph.snoise),1,fpsph);
        nbytes += sizeof(sph.snoise);
        nobj += fread(&sph.nch,sizeof(sph.nch),1,fpsph);
        nbytes += sizeof(sph.nch);
        nobj += fread(&sph.nrec,sizeof(sph.nrec),1,fpsph);
        nbytes += sizeof(sph.nrec);
        nobj += fread(&sph.dataoff,sizeof(sph.dataoff),1,fpsph);
        nbytes += sizeof(sph.dataoff);
        nobj += fread(&sph.linid,sizeof(sph.linid),1,fpsph);
        nbytes += sizeof(sph.linid);
        nobj += fread(&sph.itrans,sizeof(sph.itrans),1,fpsph);
        nbytes += sizeof(sph.itrans);
        nobj += fread(&sph.rfreq,sizeof(sph.rfreq),1,fpsph);
        nbytes += sizeof(sph.rfreq);
        nobj += fread(&sph.pasid,sizeof(sph.pasid),1,fpsph);
        nbytes += sizeof(sph.pasid);
        nobj += fread(&sph.gaiidamp,sizeof(sph.gaiidamp),1,fpsph);
        nbytes += sizeof(sph.gaiidamp);
        nobj += fread(&sph.gaiidpha,sizeof(sph.gaiidpha),1,fpsph);
        nbytes += sizeof(sph.gaiidpha);
        nobj += fread(&sph.flcid,sizeof(sph.flcid),1,fpsph);
        nbytes += sizeof(sph.flcid);
        nobj += fread(&sph.atmid,sizeof(sph.atmid),1,fpsph);
        nbytes += sizeof(sph.atmid);
 
 
/*      printf("Wrote %d variables and %d bytes to sp_read\n",nobj,nbytes); */
        return &sph ;
 
} /* end of sph_write */

/* This function reads  the code or strings header */
struct codeh_def * cdh_read (FILE * fpcodeh)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */
 
  struct codeh_def codeh;

        nbytes = 0;
        nobj = 0;
 
/*      printf("%d %d %s %s\n",codeh.icode,codeh.ncode,codeh.v_name,codeh.code); */
        nobj += fread(codeh.v_name,sizeof(codeh.v_name),1,fpcodeh);
        if (nobj == 0) {
          printf("Unexpected end of file cdh_read\n");
          exit(-1);
        }
        nbytes += sizeof(codeh.v_name);
        nobj += fread(&codeh.icode,sizeof(codeh.icode),1,fpcodeh);
        nbytes += sizeof(codeh.icode);
        nobj += fread(codeh.code,sizeof(codeh.code),1,fpcodeh);
        nbytes += sizeof(codeh.code);
        nobj += fread(&codeh.ncode,sizeof(codeh.ncode),1,fpcodeh);
        nbytes += sizeof(codeh.ncode);
 
/*      printf("Read %d variables and %d bytes to codes_read\n",nobj,nbytes); */
        return &codeh;
 
} /* end of codeh_write */ 

/* This function reads the engineering data header */
struct ant_def * enh_read(FILE * fpeng)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */

  struct ant_def ant;
 
        nbytes = 0;
        nobj = 0;
 
        nobj += fread(&ant.antennaNumber,sizeof(ant.antennaNumber),1,fpeng);
        if (nobj == 0) {
          printf("Unexpected end of file enh_read\n");
          exit(-1);
        }
        nbytes += sizeof(ant.antennaNumber);
        nobj += fread(&ant.padNumber,sizeof(ant.padNumber),1,fpeng);
        nbytes += sizeof(ant.padNumber);
        nobj += fread(&ant.antennaStatus,sizeof(ant.antennaStatus),1,fpeng);
        nbytes += sizeof(ant.antennaStatus);
        nobj += fread(&ant.trackStatus,sizeof(ant.trackStatus),1,fpeng);
        nbytes += sizeof(ant.trackStatus);
        nobj += fread(&ant.commStatus,sizeof(ant.commStatus),1,fpeng);
        nbytes += sizeof(ant.commStatus);
        nobj += fread(&ant.inhid,sizeof(ant.inhid),1,fpeng);
        nbytes += sizeof(ant.inhid);
        nobj += fread(&ant.ints,sizeof(ant.ints),1,fpeng);
        nbytes += sizeof(ant.ints);
        nobj += fread(&ant.dhrs,sizeof(ant.dhrs),1,fpeng);
        nbytes += sizeof(ant.dhrs);
        nobj += fread(&ant.ha,sizeof(ant.ha),1,fpeng);
        nbytes += sizeof(ant.ha);
        nobj += fread(&ant.lst,sizeof(ant.lst),1,fpeng);
        nbytes += sizeof(ant.lst);
        nobj += fread(&ant.pmdaz,sizeof(ant.pmdaz),1,fpeng);
        nbytes += sizeof(ant.pmdaz);
        nobj += fread(&ant.pmdel,sizeof(ant.pmdel),1,fpeng);
        nbytes += sizeof(ant.pmdel);
        nobj += fread(&ant.tiltx,sizeof(ant.tiltx),1,fpeng);
        nbytes += sizeof(ant.tiltx);
        nobj += fread(&ant.tilty,sizeof(ant.tilty),1,fpeng);
        nbytes += sizeof(ant.tilty);
        nobj += fread(&ant.actual_az,sizeof(ant.actual_az),1,fpeng);
        nbytes += sizeof(ant.actual_az);
        nobj += fread(&ant.actual_el,sizeof(ant.actual_el),1,fpeng);
        nbytes += sizeof(ant.actual_el);
        nobj += fread(&ant.azoff,sizeof(ant.azoff),1,fpeng);
        nbytes += sizeof(ant.azoff);
        nobj += fread(&ant.eloff,sizeof(ant.eloff),1,fpeng);
        nbytes += sizeof(ant.eloff);
        nobj += fread(&ant.az_tracking_error,sizeof(ant.az_tracking_error),1,fpeng);
        nbytes += sizeof(ant.az_tracking_error);
        nobj += fread(&ant.el_tracking_error,sizeof(ant.el_tracking_error),1,fpeng);
        nbytes += sizeof(ant.el_tracking_error);
        nobj += fread(&ant.refraction,sizeof(ant.refraction),1,fpeng);
        nbytes += sizeof(ant.refraction);
        nobj += fread(&ant.chopper_x,sizeof(ant.chopper_x),1,fpeng);
        nbytes += sizeof(ant.chopper_x);
        nobj += fread(&ant.chopper_y,sizeof(ant.chopper_y),1,fpeng);
        nbytes += sizeof(ant.chopper_y);
        nobj += fread(&ant.chopper_z,sizeof(ant.chopper_z),1,fpeng);
        nbytes += sizeof(ant.chopper_z);
        nobj += fread(&ant.chopper_angle,sizeof(ant.chopper_angle),1,fpeng);
        nbytes += sizeof(ant.chopper_angle);
        nobj += fread(&ant.tsys,sizeof(ant.tsys),1,fpeng);
        nbytes += sizeof(ant.tsys);
        nobj += fread(&ant.ambient_load_temperature,sizeof(ant.ambient_load_temperature),1,fpeng);        
        nbytes += sizeof(ant.ambient_load_temperature);
 
/*        printf("Read %d variables and %d bytes from eng_read\n",nobj,nbytes); */
        return &ant;
} 

struct sch_def * sch_head_read(FILE * fpsch)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */

  struct sch_def sch;
 
        nbytes = 0;
        nobj = 0;
 
        nobj += fread(&sch.inhid,sizeof(sch.inhid),1,fpsch);
        if (nobj == 0) {
          printf("Unexpected end of file sch_head_read\n");
          exit(-1);
        }
        nbytes += sizeof(sch.inhid);
        nobj += fread(sch.form,sizeof(sch.form),1,fpsch);
        nbytes += sizeof(sch.form);
        nobj += fread(&sch.nbyt,sizeof(sch.nbyt),1,fpsch);
        nbytes += sizeof(sch.nbyt);
        nobj += fread(&sch.nbyt_pack,sizeof(sch.nbyt_pack),1,fpsch);
        nbytes += sizeof(sch.nbyt_pack);
 
/*      printf("Read %d variables and %d bytes from sch_write \n",nobj,nbytes);*/
        return &sch;
 
} /* end of sch_write */ 

int sch_data_read(FILE * fpsch, long int datalength, short int * data)
{
  int nbytes;   /* counts number of bytes written */
  int nobj;     /* the number of objects written by each write */

        nbytes = 0;
        nobj = 0;
 
        nobj += fread(data,datalength*sizeof(short int),1,fpsch);
        if (nobj == 0) {
          printf("Unexpected end of file shc_data_read\n");
          exit(-1);
        }

/*      printf("Read %d variables and %d bytes from sch_data_read \n",nobj,nbytes);*/
        return nbytes;
 
} /* end of sch_data_read */ 
